/*************************************************************
 * This file was automatically generated on 2012-04-30.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge
{
	public class BrickIMU : Device 
	{
		private static byte TYPE_GET_ACCELERATION = 1;
		private static byte TYPE_GET_MAGNETIC_FIELD = 2;
		private static byte TYPE_GET_ANGULAR_VELOCITY = 3;
		private static byte TYPE_GET_ALL_DATA = 4;
		private static byte TYPE_GET_ORIENTATION = 5;
		private static byte TYPE_GET_QUATERNION = 6;
		private static byte TYPE_GET_IMU_TEMPERATURE = 7;
		private static byte TYPE_LEDS_ON = 8;
		private static byte TYPE_LEDS_OFF = 9;
		private static byte TYPE_ARE_LEDS_ON = 10;
		private static byte TYPE_SET_ACCELERATION_RANGE = 11;
		private static byte TYPE_GET_ACCELERATION_RANGE = 12;
		private static byte TYPE_SET_MAGNETOMETER_RANGE = 13;
		private static byte TYPE_GET_MAGNETOMETER_RANGE = 14;
		private static byte TYPE_SET_CONVERGENCE_SPEED = 15;
		private static byte TYPE_GET_CONVERGENCE_SPEED = 16;
		private static byte TYPE_SET_CALIBRATION = 17;
		private static byte TYPE_GET_CALIBRATION = 18;
		private static byte TYPE_SET_ACCELERATION_PERIOD = 19;
		private static byte TYPE_GET_ACCELERATION_PERIOD = 20;
		private static byte TYPE_SET_MAGNETIC_FIELD_PERIOD = 21;
		private static byte TYPE_GET_MAGNETIC_FIELD_PERIOD = 22;
		private static byte TYPE_SET_ANGULAR_VELOCITY_PERIOD = 23;
		private static byte TYPE_GET_ANGULAR_VELOCITY_PERIOD = 24;
		private static byte TYPE_SET_ALL_DATA_PERIOD = 25;
		private static byte TYPE_GET_ALL_DATA_PERIOD = 26;
		private static byte TYPE_SET_ORIENTATION_PERIOD = 27;
		private static byte TYPE_GET_ORIENTATION_PERIOD = 28;
		private static byte TYPE_SET_QUATERNION_PERIOD = 29;
		private static byte TYPE_GET_QUATERNION_PERIOD = 30;
		private static byte TYPE_ACCELERATION = 31;
		private static byte TYPE_MAGNETIC_FIELD = 32;
		private static byte TYPE_ANGULAR_VELOCITY = 33;
		private static byte TYPE_ALL_DATA = 34;
		private static byte TYPE_ORIENTATION = 35;
		private static byte TYPE_QUATERNION = 36;

		public delegate void Acceleration(short x, short y, short z);
		public delegate void MagneticField(short x, short y, short z);
		public delegate void AngularVelocity(short x, short y, short z);
		public delegate void AllData(short accX, short accY, short accZ, short magX, short magY, short magZ, short angX, short angY, short angZ, short temperature);
		public delegate void Orientation(short roll, short pitch, short yaw);
		public delegate void Quaternion(float x, float y, float z, float w);

		public BrickIMU(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_ACCELERATION] = new MessageCallback(CallbackAcceleration);
			messageCallbacks[TYPE_MAGNETIC_FIELD] = new MessageCallback(CallbackMagneticField);
			messageCallbacks[TYPE_ANGULAR_VELOCITY] = new MessageCallback(CallbackAngularVelocity);
			messageCallbacks[TYPE_ALL_DATA] = new MessageCallback(CallbackAllData);
			messageCallbacks[TYPE_ORIENTATION] = new MessageCallback(CallbackOrientation);
			messageCallbacks[TYPE_QUATERNION] = new MessageCallback(CallbackQuaternion);
		}

		public void GetAcceleration(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);

		}

		public void GetMagneticField(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETIC_FIELD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETIC_FIELD, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);

		}

		public void GetAngularVelocity(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANGULAR_VELOCITY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANGULAR_VELOCITY, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);

		}

		public void GetAllData(out short accX, out short accY, out short accZ, out short magX, out short magY, out short magZ, out short angX, out short angY, out short angZ, out short temperature)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ALL_DATA, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ALL_DATA, out answer);

			accX = LEConverter.ShortFrom(4, answer);
			accY = LEConverter.ShortFrom(6, answer);
			accZ = LEConverter.ShortFrom(8, answer);
			magX = LEConverter.ShortFrom(10, answer);
			magY = LEConverter.ShortFrom(12, answer);
			magZ = LEConverter.ShortFrom(14, answer);
			angX = LEConverter.ShortFrom(16, answer);
			angY = LEConverter.ShortFrom(18, answer);
			angZ = LEConverter.ShortFrom(20, answer);
			temperature = LEConverter.ShortFrom(22, answer);

		}

		public void GetOrientation(out short roll, out short pitch, out short yaw)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ORIENTATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ORIENTATION, out answer);

			roll = LEConverter.ShortFrom(4, answer);
			pitch = LEConverter.ShortFrom(6, answer);
			yaw = LEConverter.ShortFrom(8, answer);

		}

		public void GetQuaternion(out float x, out float y, out float z, out float w)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_QUATERNION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_QUATERNION, out answer);

			x = LEConverter.FloatFrom(4, answer);
			y = LEConverter.FloatFrom(8, answer);
			z = LEConverter.FloatFrom(12, answer);
			w = LEConverter.FloatFrom(16, answer);

		}

		public void GetIMUTemperature(out short temperature)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_IMU_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_IMU_TEMPERATURE, out answer);

			temperature = LEConverter.ShortFrom(4, answer);

		}

		public void LedsOn()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_LEDS_ON, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			sendOneWayMessage(data_);
		}

		public void LedsOff()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_LEDS_OFF, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			sendOneWayMessage(data_);
		}

		public void AreLedsOn(out bool leds)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_ARE_LEDS_ON, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_ARE_LEDS_ON, out answer);

			leds = LEConverter.BoolFrom(4, answer);

		}

		public void SetAccelerationRange(byte range)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ACCELERATION_RANGE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(range, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAccelerationRange(out byte range)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION_RANGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION_RANGE, out answer);

			range = LEConverter.ByteFrom(4, answer);

		}

		public void SetMagnetometerRange(byte range)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MAGNETOMETER_RANGE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(range, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetMagnetometerRange(out byte range)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETOMETER_RANGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETOMETER_RANGE, out answer);

			range = LEConverter.ByteFrom(4, answer);

		}

		public void SetConvergenceSpeed(ushort speed)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CONVERGENCE_SPEED, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(speed, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetConvergenceSpeed(out ushort speed)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CONVERGENCE_SPEED, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CONVERGENCE_SPEED, out answer);

			speed = LEConverter.UShortFrom(4, answer);

		}

		public void SetCalibration(byte typ, short[] data)
		{
			byte[] data_ = new byte[25];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)25, 2, data_);
			LEConverter.To(typ, 4, data_);
			LEConverter.To(data, 5, data_);


			sendOneWayMessage(data_);
		}

		public void GetCalibration(byte typ, out short[] data)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(typ, 4, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CALIBRATION, out answer);

			data = LEConverter.ShortArrayFrom(4, answer, 10);

		}

		public void SetAccelerationPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ACCELERATION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAccelerationPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetMagneticFieldPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MAGNETIC_FIELD_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetMagneticFieldPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETIC_FIELD_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETIC_FIELD_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetAngularVelocityPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANGULAR_VELOCITY_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAngularVelocityPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANGULAR_VELOCITY_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANGULAR_VELOCITY_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetAllDataPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ALL_DATA_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAllDataPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ALL_DATA_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ALL_DATA_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetOrientationPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ORIENTATION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetOrientationPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ORIENTATION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ORIENTATION_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetQuaternionPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_QUATERNION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetQuaternionPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_QUATERNION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_QUATERNION_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		public int CallbackAcceleration(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((Acceleration)callbacks[TYPE_ACCELERATION])(x, y, z);
			return 10;
		}

		public int CallbackMagneticField(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((MagneticField)callbacks[TYPE_MAGNETIC_FIELD])(x, y, z);
			return 10;
		}

		public int CallbackAngularVelocity(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((AngularVelocity)callbacks[TYPE_ANGULAR_VELOCITY])(x, y, z);
			return 10;
		}

		public int CallbackAllData(byte[] data_)
		{
			short accX = LEConverter.ShortFrom(4, data_);
			short accY = LEConverter.ShortFrom(6, data_);
			short accZ = LEConverter.ShortFrom(8, data_);
			short magX = LEConverter.ShortFrom(10, data_);
			short magY = LEConverter.ShortFrom(12, data_);
			short magZ = LEConverter.ShortFrom(14, data_);
			short angX = LEConverter.ShortFrom(16, data_);
			short angY = LEConverter.ShortFrom(18, data_);
			short angZ = LEConverter.ShortFrom(20, data_);
			short temperature = LEConverter.ShortFrom(22, data_);

			((AllData)callbacks[TYPE_ALL_DATA])(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
			return 24;
		}

		public int CallbackOrientation(byte[] data_)
		{
			short roll = LEConverter.ShortFrom(4, data_);
			short pitch = LEConverter.ShortFrom(6, data_);
			short yaw = LEConverter.ShortFrom(8, data_);

			((Orientation)callbacks[TYPE_ORIENTATION])(roll, pitch, yaw);
			return 10;
		}

		public int CallbackQuaternion(byte[] data_)
		{
			float x = LEConverter.FloatFrom(4, data_);
			float y = LEConverter.FloatFrom(8, data_);
			float z = LEConverter.FloatFrom(12, data_);
			float w = LEConverter.FloatFrom(16, data_);

			((Quaternion)callbacks[TYPE_QUATERNION])(x, y, z, w);
			return 20;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Acceleration))
			{
				callbacks[TYPE_ACCELERATION] = d;
			}
			else if(d.GetType() == typeof(MagneticField))
			{
				callbacks[TYPE_MAGNETIC_FIELD] = d;
			}
			else if(d.GetType() == typeof(AngularVelocity))
			{
				callbacks[TYPE_ANGULAR_VELOCITY] = d;
			}
			else if(d.GetType() == typeof(AllData))
			{
				callbacks[TYPE_ALL_DATA] = d;
			}
			else if(d.GetType() == typeof(Orientation))
			{
				callbacks[TYPE_ORIENTATION] = d;
			}
			else if(d.GetType() == typeof(Quaternion))
			{
				callbacks[TYPE_QUATERNION] = d;
			}
		}
	}
}
