/*************************************************************
 * This file was automatically generated on 2012-04-30.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge
{
	public class BrickletCurrent12 : Device 
	{
		private static byte TYPE_GET_CURRENT = 1;
		private static byte TYPE_CALIBRATE = 2;
		private static byte TYPE_IS_OVER_CURRENT = 3;
		private static byte TYPE_GET_ANALOG_VALUE = 4;
		private static byte TYPE_SET_CURRENT_CALLBACK_PERIOD = 5;
		private static byte TYPE_GET_CURRENT_CALLBACK_PERIOD = 6;
		private static byte TYPE_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
		private static byte TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
		private static byte TYPE_SET_CURRENT_CALLBACK_THRESHOLD = 9;
		private static byte TYPE_GET_CURRENT_CALLBACK_THRESHOLD = 10;
		private static byte TYPE_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
		private static byte TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
		private static byte TYPE_SET_DEBOUNCE_PERIOD = 13;
		private static byte TYPE_GET_DEBOUNCE_PERIOD = 14;
		private static byte TYPE_CURRENT = 15;
		private static byte TYPE_ANALOG_VALUE = 16;
		private static byte TYPE_CURRENT_REACHED = 17;
		private static byte TYPE_ANALOG_VALUE_REACHED = 18;
		private static byte TYPE_OVER_CURRENT = 19;

		public delegate void Current(short current);
		public delegate void AnalogValue(ushort value);
		public delegate void CurrentReached(short current);
		public delegate void AnalogValueReached(ushort value);
		public delegate void OverCurrent();

		public BrickletCurrent12(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_CURRENT] = new MessageCallback(CallbackCurrent);
			messageCallbacks[TYPE_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[TYPE_CURRENT_REACHED] = new MessageCallback(CallbackCurrentReached);
			messageCallbacks[TYPE_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
			messageCallbacks[TYPE_OVER_CURRENT] = new MessageCallback(CallbackOverCurrent);
		}

		public void GetCurrent(out short current)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT, out answer);

			current = LEConverter.ShortFrom(4, answer);

		}

		public void Calibrate()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_CALIBRATE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			sendOneWayMessage(data_);
		}

		public void IsOverCurrent(out bool over)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_OVER_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_IS_OVER_CURRENT, out answer);

			over = LEConverter.BoolFrom(4, answer);

		}

		public void GetAnalogValue(out ushort value)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE, out answer);

			value = LEConverter.UShortFrom(4, answer);

		}

		public void SetCurrentCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetCurrentCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetCurrentCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);


			sendOneWayMessage(data_);
		}

		public void GetCurrentCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.ShortFrom(5, answer);
			max = LEConverter.ShortFrom(7, answer);

		}

		public void SetAnalogValueCallbackThreshold(char option, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);


			sendOneWayMessage(data_);
		}

		public void GetAnalogValueCallbackThreshold(out char option, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.UShortFrom(5, answer);
			max = LEConverter.UShortFrom(7, answer);

		}

		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetDebouncePeriod(out uint debounce)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEBOUNCE_PERIOD, out answer);

			debounce = LEConverter.UIntFrom(4, answer);

		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		public int CallbackCurrent(byte[] data_)
		{
			short current = LEConverter.ShortFrom(4, data_);

			((Current)callbacks[TYPE_CURRENT])(current);
			return 6;
		}

		public int CallbackAnalogValue(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValue)callbacks[TYPE_ANALOG_VALUE])(value);
			return 6;
		}

		public int CallbackCurrentReached(byte[] data_)
		{
			short current = LEConverter.ShortFrom(4, data_);

			((CurrentReached)callbacks[TYPE_CURRENT_REACHED])(current);
			return 6;
		}

		public int CallbackAnalogValueReached(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValueReached)callbacks[TYPE_ANALOG_VALUE_REACHED])(value);
			return 6;
		}

		public int CallbackOverCurrent(byte[] data_)
		{
			((OverCurrent)callbacks[TYPE_OVER_CURRENT])();
			return 4;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Current))
			{
				callbacks[TYPE_CURRENT] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[TYPE_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(CurrentReached))
			{
				callbacks[TYPE_CURRENT_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[TYPE_ANALOG_VALUE_REACHED] = d;
			}
			else if(d.GetType() == typeof(OverCurrent))
			{
				callbacks[TYPE_OVER_CURRENT] = d;
			}
		}
	}
}
