/*************************************************************
 * This file was automatically generated on 2012-04-30.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge
{
	public class BrickletJoystick : Device 
	{
		private static byte TYPE_GET_POSITION = 1;
		private static byte TYPE_IS_PRESSED = 2;
		private static byte TYPE_GET_ANALOG_VALUE = 3;
		private static byte TYPE_CALIBRATE = 4;
		private static byte TYPE_SET_POSITION_CALLBACK_PERIOD = 5;
		private static byte TYPE_GET_POSITION_CALLBACK_PERIOD = 6;
		private static byte TYPE_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
		private static byte TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
		private static byte TYPE_SET_POSITION_CALLBACK_THRESHOLD = 9;
		private static byte TYPE_GET_POSITION_CALLBACK_THRESHOLD = 10;
		private static byte TYPE_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
		private static byte TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
		private static byte TYPE_SET_DEBOUNCE_PERIOD = 13;
		private static byte TYPE_GET_DEBOUNCE_PERIOD = 14;
		private static byte TYPE_POSITION = 15;
		private static byte TYPE_ANALOG_VALUE = 16;
		private static byte TYPE_POSITION_REACHED = 17;
		private static byte TYPE_ANALOG_VALUE_REACHED = 18;
		private static byte TYPE_PRESSED = 19;
		private static byte TYPE_RELEASED = 20;

		public delegate void Position(short x, short y);
		public delegate void AnalogValue(ushort x, ushort y);
		public delegate void PositionReached(short x, short y);
		public delegate void AnalogValueReached(ushort x, ushort y);
		public delegate void Pressed();
		public delegate void Released();

		public BrickletJoystick(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_POSITION] = new MessageCallback(CallbackPosition);
			messageCallbacks[TYPE_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[TYPE_POSITION_REACHED] = new MessageCallback(CallbackPositionReached);
			messageCallbacks[TYPE_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
			messageCallbacks[TYPE_PRESSED] = new MessageCallback(CallbackPressed);
			messageCallbacks[TYPE_RELEASED] = new MessageCallback(CallbackReleased);
		}

		public void GetPosition(out short x, out short y)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_POSITION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_POSITION, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);

		}

		public void IsPressed(out bool pressed)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_PRESSED, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_IS_PRESSED, out answer);

			pressed = LEConverter.BoolFrom(4, answer);

		}

		public void GetAnalogValue(out ushort x, out ushort y)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE, out answer);

			x = LEConverter.UShortFrom(4, answer);
			y = LEConverter.UShortFrom(6, answer);

		}

		public void Calibrate()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_CALIBRATE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			sendOneWayMessage(data_);
		}

		public void SetPositionCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetPositionCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_POSITION_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetPositionCallbackThreshold(char option, short minX, short maxX, short minY, short maxY)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(minX, 5, data_);
			LEConverter.To(maxX, 7, data_);
			LEConverter.To(minY, 9, data_);
			LEConverter.To(maxY, 11, data_);


			sendOneWayMessage(data_);
		}

		public void GetPositionCallbackThreshold(out char option, out short minX, out short maxX, out short minY, out short maxY)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_POSITION_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			minX = LEConverter.ShortFrom(5, answer);
			maxX = LEConverter.ShortFrom(7, answer);
			minY = LEConverter.ShortFrom(9, answer);
			maxY = LEConverter.ShortFrom(11, answer);

		}

		public void SetAnalogValueCallbackThreshold(char option, ushort minX, ushort maxX, ushort minY, ushort maxY)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(minX, 5, data_);
			LEConverter.To(maxX, 7, data_);
			LEConverter.To(minY, 9, data_);
			LEConverter.To(maxY, 11, data_);


			sendOneWayMessage(data_);
		}

		public void GetAnalogValueCallbackThreshold(out char option, out ushort minX, out ushort maxX, out ushort minY, out ushort maxY)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			minX = LEConverter.UShortFrom(5, answer);
			maxX = LEConverter.UShortFrom(7, answer);
			minY = LEConverter.UShortFrom(9, answer);
			maxY = LEConverter.UShortFrom(11, answer);

		}

		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetDebouncePeriod(out uint debounce)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEBOUNCE_PERIOD, out answer);

			debounce = LEConverter.UIntFrom(4, answer);

		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		public int CallbackPosition(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);

			((Position)callbacks[TYPE_POSITION])(x, y);
			return 8;
		}

		public int CallbackAnalogValue(byte[] data_)
		{
			ushort x = LEConverter.UShortFrom(4, data_);
			ushort y = LEConverter.UShortFrom(6, data_);

			((AnalogValue)callbacks[TYPE_ANALOG_VALUE])(x, y);
			return 8;
		}

		public int CallbackPositionReached(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);

			((PositionReached)callbacks[TYPE_POSITION_REACHED])(x, y);
			return 8;
		}

		public int CallbackAnalogValueReached(byte[] data_)
		{
			ushort x = LEConverter.UShortFrom(4, data_);
			ushort y = LEConverter.UShortFrom(6, data_);

			((AnalogValueReached)callbacks[TYPE_ANALOG_VALUE_REACHED])(x, y);
			return 8;
		}

		public int CallbackPressed(byte[] data_)
		{
			((Pressed)callbacks[TYPE_PRESSED])();
			return 4;
		}

		public int CallbackReleased(byte[] data_)
		{
			((Released)callbacks[TYPE_RELEASED])();
			return 4;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Position))
			{
				callbacks[TYPE_POSITION] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[TYPE_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(PositionReached))
			{
				callbacks[TYPE_POSITION_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[TYPE_ANALOG_VALUE_REACHED] = d;
			}
			else if(d.GetType() == typeof(Pressed))
			{
				callbacks[TYPE_PRESSED] = d;
			}
			else if(d.GetType() == typeof(Released))
			{
				callbacks[TYPE_RELEASED] = d;
			}
		}
	}
}
