/*************************************************************
 * This file was automatically generated on 2012-04-30.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge
{
	public class BrickletTemperatureIR : Device 
	{
		private static byte TYPE_GET_AMBIENT_TEMPERATURE = 1;
		private static byte TYPE_GET_OBJECT_TEMPERATURE = 2;
		private static byte TYPE_SET_EMISSIVITY = 3;
		private static byte TYPE_GET_EMISSIVITY = 4;
		private static byte TYPE_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 5;
		private static byte TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 6;
		private static byte TYPE_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 7;
		private static byte TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 8;
		private static byte TYPE_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 9;
		private static byte TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 10;
		private static byte TYPE_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 11;
		private static byte TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 12;
		private static byte TYPE_SET_DEBOUNCE_PERIOD = 13;
		private static byte TYPE_GET_DEBOUNCE_PERIOD = 14;
		private static byte TYPE_AMBIENT_TEMPERATURE = 15;
		private static byte TYPE_OBJECT_TEMPERATURE = 16;
		private static byte TYPE_AMBIENT_TEMPERATURE_REACHED = 17;
		private static byte TYPE_OBJECT_TEMPERATURE_REACHED = 18;

		public delegate void AmbientTemperature(short temperature);
		public delegate void ObjectTemperature(short temperature);
		public delegate void AmbientTemperatureReached(short temperature);
		public delegate void ObjectTemperatureReached(short temperature);

		public BrickletTemperatureIR(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_AMBIENT_TEMPERATURE] = new MessageCallback(CallbackAmbientTemperature);
			messageCallbacks[TYPE_OBJECT_TEMPERATURE] = new MessageCallback(CallbackObjectTemperature);
			messageCallbacks[TYPE_AMBIENT_TEMPERATURE_REACHED] = new MessageCallback(CallbackAmbientTemperatureReached);
			messageCallbacks[TYPE_OBJECT_TEMPERATURE_REACHED] = new MessageCallback(CallbackObjectTemperatureReached);
		}

		public void GetAmbientTemperature(out short temperature)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_AMBIENT_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_AMBIENT_TEMPERATURE, out answer);

			temperature = LEConverter.ShortFrom(4, answer);

		}

		public void GetObjectTemperature(out short temperature)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_OBJECT_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_OBJECT_TEMPERATURE, out answer);

			temperature = LEConverter.ShortFrom(4, answer);

		}

		public void SetEmissivity(ushort emissivity)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_EMISSIVITY, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(emissivity, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetEmissivity(out ushort emissivity)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_EMISSIVITY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_EMISSIVITY, out answer);

			emissivity = LEConverter.UShortFrom(4, answer);

		}

		public void SetAmbientTemperatureCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetAmbientTemperatureCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetObjectTemperatureCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetObjectTemperatureCallbackPeriod(out uint period)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, out answer);

			period = LEConverter.UIntFrom(4, answer);

		}

		public void SetAmbientTemperatureCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);


			sendOneWayMessage(data_);
		}

		public void GetAmbientTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.ShortFrom(5, answer);
			max = LEConverter.ShortFrom(7, answer);

		}

		public void SetObjectTemperatureCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);


			sendOneWayMessage(data_);
		}

		public void GetObjectTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.ShortFrom(5, answer);
			max = LEConverter.ShortFrom(7, answer);

		}

		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);


			sendOneWayMessage(data_);
		}

		public void GetDebouncePeriod(out uint debounce)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);


			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEBOUNCE_PERIOD, out answer);

			debounce = LEConverter.UIntFrom(4, answer);

		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		public int CallbackAmbientTemperature(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((AmbientTemperature)callbacks[TYPE_AMBIENT_TEMPERATURE])(temperature);
			return 6;
		}

		public int CallbackObjectTemperature(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((ObjectTemperature)callbacks[TYPE_OBJECT_TEMPERATURE])(temperature);
			return 6;
		}

		public int CallbackAmbientTemperatureReached(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((AmbientTemperatureReached)callbacks[TYPE_AMBIENT_TEMPERATURE_REACHED])(temperature);
			return 6;
		}

		public int CallbackObjectTemperatureReached(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((ObjectTemperatureReached)callbacks[TYPE_OBJECT_TEMPERATURE_REACHED])(temperature);
			return 6;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(AmbientTemperature))
			{
				callbacks[TYPE_AMBIENT_TEMPERATURE] = d;
			}
			else if(d.GetType() == typeof(ObjectTemperature))
			{
				callbacks[TYPE_OBJECT_TEMPERATURE] = d;
			}
			else if(d.GetType() == typeof(AmbientTemperatureReached))
			{
				callbacks[TYPE_AMBIENT_TEMPERATURE_REACHED] = d;
			}
			else if(d.GetType() == typeof(ObjectTemperatureReached))
			{
				callbacks[TYPE_OBJECT_TEMPERATURE_REACHED] = d;
			}
		}
	}
}
